/*
editWorkoutFragment.java created by Alex Dowlding
 */
package com.example.alex.liftcoach;

import android.app.Activity;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.Toast;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import static android.content.Context.MODE_PRIVATE;

/**
 * A simple {@link Fragment} subclass.
 * Activities that contain this fragment must implement the
 * {@link editWorkoutFragment.OnFragmentInteractionListener} interface
 * to handle interaction events.
 * Use the {@link editWorkoutFragment#newInstance} factory method to
 * create an instance of this fragment.
 */
public class editWorkoutFragment extends Fragment{
    // TODO: Rename parameter arguments, choose names that match
    // the fragment initialization parameters, e.g. ARG_ITEM_NUMBER
    OnEditButtonSelectedListener mCallback;
    private static final String ARG_PARAM1 = "param1";
    private static final String ARG_PARAM2 = "param2";
    private OnEditButtonSelectedListener listener;
    private ArrayAdapter<String> adapter;
    // TODO: Rename and change types of parameters
    private String mParam1;
    private String mParam2;
    private String filename;
    private String tempfilename = "tempfile";
    String workoutTitleMarker = "#####";
    private String sentWorkoutName;
    ArrayList<String> workoutList = new ArrayList<String>();
    ListView workouts;
    ImageButton newWorkoutButton;
    ImageButton editWorkoutButton;
    ImageButton deleteWorkoutButton;

    View view;

    public editWorkoutFragment() {
        // Required empty public constructor
    }

    /**
     * Use this factory method to create a new instance of
     * this fragment using the provided parameters.
     *
     * @param param1 Parameter 1.
     * @param param2 Parameter 2.
     * @return A new instance of fragment editWorkoutFragment.
     */
    // TODO: Rename and change types and number of parameters
    public static editWorkoutFragment newInstance(String param1, String param2) {
        editWorkoutFragment fragment = new editWorkoutFragment();
        Bundle args = new Bundle();
        args.putString(ARG_PARAM1, param1);
        args.putString(ARG_PARAM2, param2);
        fragment.setArguments(args);
        return fragment;
    }

    /* ###########################################################
    onCreate is a auto generated method that will retrieve parameters
    if they were sent to the fragment.
     */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (getArguments() != null) {
            mParam1 = getArguments().getString(ARG_PARAM1);
            mParam2 = getArguments().getString(ARG_PARAM2);
        }
    }

    // TODO: Rename method, update argument and hook method into UI event
    /* ###########################################################
    onAttach is an auto generated method that helps attach the fragment
    to the activity.  It also will link mCallback to the OnEditButtonSelectedListener
    event.
     */
    @Override
    public void onAttach(Activity activity) {
        super.onAttach(activity);

        try {
            mCallback = (OnEditButtonSelectedListener) activity;
        } catch (ClassCastException e) {
            throw new ClassCastException(activity.toString()
                    + " must implement OnHeadlineSelectedListener");
        }
    }

    /**
     * This interface must be implemented by activities that contain this
     * fragment to allow an interaction in this fragment to be communicated
     * to the activity and potentially other fragments contained in that
     * activity.
     * <p>
     * See the Android Training lesson <a href=
     * "http://developer.android.com/training/basics/fragments/communicating.html"
     * >Communicating with Other Fragments</a> for more information.
     */
    public interface OnFragmentInteractionListener {
        // TODO: Update argument type and name
        void onFragmentInteraction(Uri uri);
    }

    /* #############################################################
    Name: OnEditButtonSelectedListener
    Retrieves and sets an instance of the MainActivity method
    onEditButtonClicked
    ############################################################# */
    public interface OnEditButtonSelectedListener
    {
        public void onEditButtonClicked(String workoutName);
    }


    /* ##################################################################################
    onCreateView sets up all on screen entities by calling a method.  It also creates and sets
    various listening events. It also sets the defaults for the fragment.
     */
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState)
    {
        view = inflater.inflate(R.layout.fragment_edit_workout, container, false);

        filename = getString(R.string.filename); //get file from resources
        SetupEntities();//set up on screen elements
        ReadFile();

        adapter = new ArrayAdapter<String>(getContext(),android.R.layout.simple_list_item_single_choice, workoutList);
        //setup new adapter for the list
        workouts.setAdapter(adapter);
        //attach the adapter to the listview

        workouts.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                sentWorkoutName = (String) (workouts.getItemAtPosition(position));
                //on each click, sets the workout variable according to what is clicked
            }
        });

        newWorkoutButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                sentWorkoutName = "NewWorkout";//default name
                mCallback.onEditButtonClicked(sentWorkoutName);
                //this utilizes the edit event but it still works for new.
            }
        });

        editWorkoutButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                int checkedPos;
                checkedPos = workouts.getCheckedItemPosition();//making sure the right name is retrieved
                String workoutName = (String) workouts.getItemAtPosition(checkedPos);//get name
                mCallback.onEditButtonClicked(workoutName);//call the edit event
            }
        });

        deleteWorkoutButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                int checkedPos;
                checkedPos = workouts.getCheckedItemPosition();
                String workoutName = (String) workouts.getItemAtPosition(checkedPos);
                //retrieve string to delete
                DeleteWorkout(workoutName);//delete the workout
                workoutList.remove(workoutName);//make sure it is changed
                adapter.notifyDataSetChanged();//reflect the removal in the UI
                if (workoutList.isEmpty())
                {
                    //disable these buttons if no workouts to use these actions on
                    deleteWorkoutButton.setEnabled(false);
                    editWorkoutButton.setEnabled(false);
                }
                else
                    workouts.setItemChecked(0, true);//otherwise check the very first workout by default
            }
        });

        if (workoutList.isEmpty())
        {
            editWorkoutButton.setEnabled(false);
            deleteWorkoutButton.setEnabled(false);
            //if no workouts at the start of fragment, disable buttons
        }
        else
        {
            //otherwise make sure they are enabled
            editWorkoutButton.setEnabled(true);
            deleteWorkoutButton.setEnabled(true);
            workouts.setItemChecked(0, true);
            //check the first item by default
        }

            return view;
    }


    /* ############################################################################
    ReadFile reads the data file and determines which workouts are available from the file.
    Then it adds these workouts to the list so that they can be viewed.
     */
    private void ReadFile()
    {
        workoutList.clear();//make sure list is empty in case back was pressed
        try {
            String Message;
            FileInputStream fileInputStream = getActivity().openFileInput(filename);
            InputStreamReader inputStreamReader = new InputStreamReader(fileInputStream);
            BufferedReader bufferedReader = new BufferedReader(inputStreamReader);
            int index = 0; //start at 0 in the list

            while ((Message = bufferedReader.readLine()) != null)//while not eof
            {
                if(Message.contentEquals(workoutTitleMarker))//we found a workout
                {
                    Message = bufferedReader.readLine();//the next line will have the name
                    workoutList.add(index, Message);//add to the list
                    index++;
                }
            }
            fileInputStream.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }

    }

    /* ###################################################################
    DeleteWorkout will delete the selected workout from file.  It creates a new
    temp file and copies everything except the workout that is meant to be deleted.
    Then the temp file is renamed as the real file.
     */
    private void DeleteWorkout(String workoutName)
    {
        File fileName = getContext().getFileStreamPath(filename);//get real file
        File tempFile = getContext().getFileStreamPath(tempfilename);//get temp file
        String line;

        try {
            FileOutputStream fileTempOutputStream = getContext().openFileOutput(tempfilename, MODE_PRIVATE);
            //Private means all contents will be deleted and replaced by what I write
            FileInputStream fileInputStream = getActivity().openFileInput(filename);
            InputStreamReader inputStreamReader = new InputStreamReader(fileInputStream);
            BufferedReader bufferedReader = new BufferedReader(inputStreamReader);

            while ((line = bufferedReader.readLine()) != null) //while not eof
            {
                if (line.contentEquals(workoutTitleMarker))//we found a workout
                {
                    line = bufferedReader.readLine();//this is the workout name
                    if (line.contentEquals(workoutName))//if we found the target workout
                    {
                        while (line != null && !line.contentEquals(workoutTitleMarker))
                        {
                            //just read lines until the workout is done
                            line = bufferedReader.readLine();
                        }

                        if (line == null)
                            break;//no more workouts

                        else
                        {
                            //there is another workout so must write this info
                            fileTempOutputStream.write(workoutTitleMarker.getBytes());
                            fileTempOutputStream.write('\n');
                        }
                    }
                    else
                    {
                        //not target workout, write this info
                        fileTempOutputStream.write(workoutTitleMarker.getBytes());
                        fileTempOutputStream.write('\n');
                        fileTempOutputStream.write(line.getBytes());
                        fileTempOutputStream.write('\n');
                    }
                }
                else
                {
                    //write lines verbatim
                    fileTempOutputStream.write(line.getBytes());
                    fileTempOutputStream.write('\n');
                }
            }
            fileInputStream.close();
            fileTempOutputStream.close();
            fileName.delete();
            tempFile.renameTo(fileName);
            Toast.makeText(getContext(), "Workout Deleted", Toast.LENGTH_LONG).show();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /* ##########################################################
    SetupEntities lets me access on screen elements located in the .xml
    file using code.
     */
    private void SetupEntities()
    {
        workouts = (ListView) view.findViewById(R.id.WorkoutListListView);
        newWorkoutButton = (ImageButton) view.findViewById(R.id.newWorkoutButton);
        editWorkoutButton = (ImageButton) view.findViewById(R.id.editWorkoutButton);
        deleteWorkoutButton = (ImageButton) view.findViewById(R.id.deleteWorkoutButton);
    }
}

