/*
homeFragment.java created by Alex Dowlding
 */
package com.example.alex.liftcoach;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v7.preference.PreferenceManager;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Locale;
import static android.content.Context.MODE_APPEND;
import static android.content.Context.MODE_PRIVATE;

/**
 * A simple {@link Fragment} subclass.
 * Activities that contain this fragment must implement the
 * {@link homeFragment.OnFragmentInteractionListener} interface
 * to handle interaction events.
 * Use the {@link homeFragment#newInstance} factory method to
 * create an instance of this fragment.
 */
public class homeFragment extends Fragment {
    // TODO: Rename parameter arguments, choose names that match
    // the fragment initialization parameters, e.g. ARG_ITEM_NUMBER
    private static final String ARG_PARAM1 = "param1";
    private static final String ARG_PARAM2 = "param2";

    // TODO: Rename and change types of parameters

    DonutProgress goalProgress;
    Button startWorkout;
    TextView greetingTextview;

    private String mParam1;
    private String mParam2;
    private String logfileName;
    private float recordCount;
    private Context ctx;

    View view;
    private OnFragmentInteractionListener mListener;

    public homeFragment() {
        // Required empty public constructor
    }

    /**
     * Use this factory method to create a new instance of
     * this fragment using the provided parameters.
     *
     * @param param1 Parameter 1.
     * @param param2 Parameter 2.
     * @return A new instance of fragment homeFragment.
     */
    // TODO: Rename and change types and number of parameters
    public static homeFragment newInstance(String param1, String param2) {
        homeFragment fragment = new homeFragment();
        Bundle args = new Bundle();
        args.putString(ARG_PARAM1, param1);
        args.putString(ARG_PARAM2, param2);
        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (getArguments() != null) {
            mParam1 = getArguments().getString(ARG_PARAM1);
            mParam2 = getArguments().getString(ARG_PARAM2);
        }
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        view = inflater.inflate(R.layout.fragment_home, container, false);

        SetupEntities();//setup and link all on screen elements
        logfileName = getString(R.string.logfile);//retrieve log file name
        SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(ctx);
        //returns an instance of my sharedpreferences for the application

        recordCount = 0;//used for calculating the progress, make sure it starts at 0
        ReadAmendRecords();//read the records file and set recordCount accordingly
        float goalPercent = recordCount/(float) prefs.getInt("goalSlider", 5);//get goal from preferences
        goalPercent *= 100;//enlarge percent
        if (goalPercent > 100)
            goalProgress.setProgress(100);
        else
            goalProgress.setProgress((int)goalPercent); //don't want long decimals

        greetingTextview.append(" " + prefs.getString("theUserName", null) + "!");
        //make the greeting say the users name from preferences

        startWorkout.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(getActivity(), chooseWorkoutActivity.class);
                startActivity(intent); //start the chooseWorkout activity
            }
        });

        return view;
    }

    /* ###################################################################
    Auto generated by Android Studio
     */
    // TODO: Rename method, update argument and hook method into UI event
    public void onButtonPressed(Uri uri) {
        if (mListener != null) {
            mListener.onFragmentInteraction(uri);
        }
    }

    /* ###############################################################
    Auto generated by Android Studio.  Handles fragment being attached
    to the activity.
     */
    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
        ctx = context;
        if (context instanceof OnFragmentInteractionListener) {
            mListener = (OnFragmentInteractionListener) context;
        } else {
            throw new RuntimeException(context.toString()
                    + " must implement OnFragmentInteractionListener");
        }
    }

    /* #################################
    Auto generated by Android Studio.  Handles detach.
     */
    @Override
    public void onDetach() {
        super.onDetach();
        mListener = null;
    }

    /**
     * This interface must be implemented by activities that contain this
     * fragment to allow an interaction in this fragment to be communicated
     * to the activity and potentially other fragments contained in that
     * activity.
     * <p>
     * See the Android Training lesson <a href=
     * "http://developer.android.com/training/basics/fragments/communicating.html"
     * >Communicating with Other Fragments</a> for more information.
     */
    public interface OnFragmentInteractionListener {
        // TODO: Update argument type and name
        void onFragmentInteraction(Uri uri);
    }

    /* ###############################################################################
    ReadAmendRecords will search in the log file and read how many workout entries there are.
    If an entry is too old, it will be deleted.  Then the number of valid entries is stored in
    recordCount
     */
    private void ReadAmendRecords()
    {
        File fileName = getContext().getFileStreamPath(logfileName);//get logfile
        File tempName = getContext().getFileStreamPath("tempfile");//get tempfile
        try {
            String line;
            FileOutputStream fileTempOutputStream = getContext().openFileOutput("tempfile", MODE_PRIVATE);
            //destroys existing contents
            FileOutputStream fileOutputStream = getContext().openFileOutput(logfileName, MODE_PRIVATE | MODE_APPEND);
            //is private but appends
            fileOutputStream.close(); //just make it exist if it doesn't
            FileInputStream fileInputStream = getContext().openFileInput(logfileName);
            InputStreamReader inputStreamReader = new InputStreamReader(fileInputStream);
            BufferedReader bufferedReader = new BufferedReader(inputStreamReader);

            DateFormat format = new SimpleDateFormat("MMMM d, yyyy", Locale.ENGLISH);
            Date nowDate = new Date();
            Calendar cal = GregorianCalendar.getInstance();
            cal.add(Calendar.DAY_OF_YEAR, -7);//subtract 7 days
            nowDate = cal.getTime();

            while ((line = bufferedReader.readLine()) != null)
            {
                Date recordedDate = format.parse(line);//parses line from file into date format specified above
                if (!recordedDate.before(nowDate))
                {
                    //write if it is new enough
                    fileTempOutputStream.write(line.getBytes());
                    fileTempOutputStream.write('\n');
                    recordCount++;
                }
                //otherwise do nothing and read the next line
            }

            fileInputStream.close();
            fileOutputStream.close();
            fileTempOutputStream.close();

            fileName.delete();//make the tempfile the real file so it can be read again
            tempName.renameTo(fileName);

        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (ParseException e) {
            e.printStackTrace();
        }
    }

    /* #############################################################
    SetupEntities creates variables for on screen elements and links them
    to the .xml assets.
     */
    private void SetupEntities()
    {
        goalProgress = (DonutProgress) view.findViewById(R.id.goalDonutProgress);
        startWorkout = (Button) view.findViewById(R.id.chooseWorkoutButton);
        greetingTextview = (TextView) view.findViewById(R.id.homeGreetingTextView);
    }
}



